=== debian/changelog ===
opentracing-cpp (1.6.0-2ubuntu1) jammy; urgency=medium

  * d/p/fix-ftbfs-glibc-2.34.patch: Fix FTBFS with glibc 2.34.
    (LP: #1951665)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 19 Nov 2021 20:02:14 -0500

opentracing-cpp (1.6.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Stephen Gelman <ssgelm@debian.org>  Sun, 07 Nov 2021 00:42:53 -0500

opentracing-cpp (1.6.0-1) experimental; urgency=medium

  * Initial release (Closes: #991193)

 -- Stephen Gelman <ssgelm@debian.org>  Wed, 14 Jul 2021 11:52:00 -0500
