=== debian/control ===
Source: opentracing-cpp
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Stephen Gelman <ssgelm@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/opentracing/opentracing-cpp/
Vcs-Browser: https://salsa.debian.org/ssgelm/opentracing-cpp
Vcs-Git: https://salsa.debian.org/ssgelm/opentracing-cpp.git
Rules-Requires-Root: no

Package: libopentracing-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libopentracing1 (= ${binary:Version}), ${misc:Depends}
Description: OpenTracing API for C++ Dev Libraries
 C++ implementation of the OpenTracing API see http://opentracing.io
 for additional information. Library is in libopentracing1

Package: libopentracing1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenTracing API for C++
 C++ implementation of the OpenTracing API see http://opentracing.io
 for additional information
